//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
#include "Client.h"

extern char ** _argv;
extern int _argc;

void __fastcall ClientThread::Execute()
{
    if (_argc < 2)  {
        ShowMessage("Error: You must provide a Subscriber Name as an argument.");
        return;
    }
    
	CORBA::ORB_var orb = CORBA::ORB_init(_argc, _argv);
	CORBA::BOA_var boa = orb->BOA_init(_argc, _argv);

	Client client(_argv[1]);
	boa->obj_is_ready(&client);

    Publisher_var publisher;
	try {
		publisher = Publisher::_bind();
	}
	catch (const CORBA::Exception& e) {
		Form1->Memo1->Lines->Add("Client: Unable to bind to publisher.");
		Form1->Memo1->Lines->Add(e._name());
		return;
	}

	Form1->Memo1->Lines->Add("Successfully bound to publisher");
    Form1->publisher = publisher;

	try {
		publisher->add_subscriber(&client);
	}
	catch (const CORBA::Exception& e) {
		Form1->Memo1->Lines->Add("Client: Unable to add subscriber.");
		Form1->Memo1->Lines->Add(e._name());
		return;
	}

    Form1->UpdateSubscriberList();
	boa->impl_is_ready();	// Wait for incoming calls
	return;
}

//---------------------------------------------------------------------------
#pragma package(smart_init)
