//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
#include "Client.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    ClientDataSet1->FieldDefs->Add("Subscriber Name", ftString, 15, False);
    ClientDataSet1->FieldDefs->Add("Log on Time", ftTime, 0, False);
    ClientDataSet1->CreateDataSet();
    ClientDataSet1->Open();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    new ClientThread();    // automatic clean up by TThread 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    UpdateSubscriberList();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdateSubscriberList()
{
        if (!publisher)
            return;
        ClientDataSet1->DisableControls();
        ClientDataSet1->First();
        while (!ClientDataSet1->Eof)
            ClientDataSet1->Delete();

        try{
            SubscriberList_ptr s = publisher->get_subscribers();
            for (CORBA::ULong i = 0; i < s->length(); i++)
            {
                ClientDataSet1->Append();
                ClientDataSet1->FieldValues["Subscriber Name"] = (*s)[i]->get_name();
                ClientDataSet1->FieldValues["Log on Time"] = (*s)[i]->get_time().val;
            }
            SubscriberList::_release(s);
        }
        catch (CORBA::Exception& e){
    		Form1->Memo1->Lines->Add("Client: Unable to bind to publisher.");
	    	Form1->Memo1->Lines->Add(e._name());
		    return;
	    }

        ClientDataSet1->EnableControls();
}
